function [zero,iter,xvect,xdif,fx]=aitken(fun,phi,x0,tol,nmax)
% AITKEN estrapolazione di Aitken.
% [ZERO,ITER,XVECT,XDIF,FX]=AITKEN(FUN,PHI,X0,TOL,NMAX) cerca lo zero di
% una funzione continua FUN usando l'estrapolazione di Aitken, partendo dal
% dato iniziale X0. FUN riceve in ingresso lo scalare x e restituisce un
% valore scalare reale. TOL specifica la tolleranza del metodo.
% ZERO e` l'approssimazione della radice, ITER e` il numero di iterate svolte,
% XVECT e` il vettore delle iterate, XDIF il vettore delle differenze tra
% iterate successive, FX il vettore dei residui.
err=tol+1; iter=0;
fx0=fun(x0); xdif=[]; xvect=x0; fx=fx0; zero=[];
phix=phi(x0);
while err >= tol && iter <=nmax
    x=phi(x0); phixx=phi(x);
    den=phixx-2*x+x0;
    if den == 0,
        error('Azzeramento del denominatore'); return
    end
    xn=(x0*phixx-x^2)/den;
    xvect=[xvect; xn];
    xdif=[xdif; abs(xn-x0)];
    x0=xn; fx0=fun(x0);
    fx=[fx; fx0]; err=abs(fx0);
    iter=iter+1;
end
zero=xvect(end);
return
