function [x]=backwardcol(U,b)
% BACKWARDCOL sostituzioni all'indietro: versione orientata per colonne.
%  X=BACKWARDCOL(U,B) risolve il sistema triangolare superiore U*X=B con il
%  metodo delle sostituzioni all'indietro nella versione orientata per colonne.
[n,m]=size(U); x=[];
if n ~= m, warning('Solo sistemi quadrati'); return; end
if min(abs(diag(U))) == 0, error('Sistema singolare'); end
x=b;
for j = n:-1:2
    x(j)=x(j)/U(j,j); x(1:j-1)=x(1:j-1)-x(j)*U(1:j-1,j);
end
x(1) = x(1)/U(1,1);
return
