function [x,iter]=broyden(F,Q,x0,tol,nmax)
% BROYDEN metodo di Broyden per sistemi non lineari.
%  [X, ITER] = BROYDEN(F, Q, X0, TOL, NMAX) risolve il sistema non lineare
%  F(X)=0 con il metodo di Broyden. F e` una stringa contenente le espressioni
%  funzionali delle equazioni non lineari del sistema.
%  X0 specifica il vettore iniziale, TOL la tolleranza del metodo, NMAX il
%  numero massimo delle iterazioni. ITER e` l'iterazione alla quale la
%  soluzione X e` calcolata.
[n,m]=size(F);
if n ~= m, error('Solo sistemi quadrati'); end
iter=0; err=1+tol;
fk0=F(x0);
    while iter < nmax && err > tol
        s=-Q \ fk0;
        x=s+x0;
        err=norm(s);
        if err > tol
            fk=F(x);
            Q=Q+(fk*s')/(s'*s);
        end
        iter=iter+1;
        fk0=fk; x0=x;
    end
return
