function [A]=chol2(A)
% CHOL2 fattorizzazione di Cholesky di una matrice A di tipo s.d.p..
% H=CHOL2(A) produce una matrice triangolare superiore H tale che H'*H=A.
[n,m]=size(A);
if n ~= m, error('Solo sistemi quadrati'); end
A(1,1)=sqrt(A(1,1));
for j=2:n
     for i=1:j-1
       if A(j,j) <= 0, error('Elemento pivotale nullo o negativo'); end
       A(i,j)=(A(i,j)-(A(1:i-1,i))'*A(1:i-1,j))/A(i,i);
    end
    A(j,j)=sqrt(A(j,j)-(A(1:j-1,j))'*A(1:j-1,j));
end
return
