function [a,b]=coefherm(n)
% COEFHERM coefficienti dei polinomi di Hermite.
%   [A,B]=COEFHERM(N): A e B sono i coefficienti alpha(k) e beta(k)
%   del polinomio di Hermite di grado N.
if n<=1, error('n deve essere >1 '); end
a=zeros(n,1); b=zeros(n,1); b(1)=sqrt(4.*atan(1.));
k=[2:n]; b(k)=0.5*(k-1);
return
