function [D,sweep,rotation,psi]=cycjacobi(A,tol,nmax)
% CYCJACOBI metodo di Jacobi Ciclico.
%  [D,SWN,ROTN,PSI]=CYCJACOBI(A,TOL) calcola gli autovalori della matrice
%  simmetrica A. TOL specifica la tolleranza del metodo, NMAX il massimo
%  numero di rotazioni possibili. In output: la diagonale di D contiente
%  gli autovalori di A, SWEEP e` il numero di sweep effettuati e ROTATION e` il
%  numero totale di rotazioni applicate. PSI=PSINORM(D).
[n,m]=size(A);
if n~=m, error('Solo matrici quadrate'); end
D=A;
psi=norm(A,'fro');
epsi=tol*psi;
 psi=psinorm(D);
 rotation=0;sweep=0;
 while psi>epsi && rotation<=nmax
     for p=1:n-1
         for q=p+1:n
             rotation = rotation + 1;
             [c,s]=symschur(D,p,q);
             [D]=gacol(D,c,s,1,n,p,q);
             [D]=garow(D,c,s,p,q,1,n);
         end
     end
     psi=psinorm(D);
     if rem(rotation,n*(n-1)/2)==0
         sweep=sweep+1;
%         fprintf('sweep=%d, psi=%13.6e\n',sweep,psi)
     end
 end
 return
