function [d]=dividif(x,y)
% DIVIDIF differenze divise di Newton.
%  [D] = DIVIDIF(X, Y) calcola la differenza divisa di ordine n.
%  X contiene i nodi di interpolazione, Y contiene i valori della funzione in X
%  e la matrice D contiene tutte le differenze divise calcolate sui dati.
%  diag(D) contiene le differenze divise f[x0], ....,f[x0,...,xn]
np=length(x);  d=zeros(np);  d(:,1)=y;
for i=2:np
    d(i+1:np,i)=d(i+1:np,i-1);
    for j=np:-1:i
        d(j,i)=(d(j,i-1)-d(j-1,i-1))/(x(j)-x(j-i+1));
    end
end
return
