function [T,Q,R]=hessqr(A,nmax)
% HESSQR metodo Hessenberg-QR.
%  [T,Q,R]=HESSQR(A,NMAX) trasforma A in forma di Hessenberg superiore
%  mediante l'algoritmo di Householder e poi esegue NMAX iterazioni
%  del metodo QR utilizzando matrici di rotazione di Givens.
[n,m]=size(A);
if n~=m, error('Solo matrici quadrate'); end
[T,Qhess]=houshess(A);
for j=1:nmax
    [Q,R,c,s]= qrgivens(T);
    T=R;
    for k=1:n-1,
        T=gacol(T,c(k),s(k),1,k+1,k,k+1);
    end
end
return
