function [y1]=interpol(x,y,x1)
% INTERPOL interpolazione polinomiale di Lagrange.
% [Y1] = INTERPOL(X, Y, X1) calcola il polinomio interpolatore di Lagrange di
% un insieme di dati. X contiene i nodi di interpolazione, Y contiene i valori
% sui cui costruire l'interpolatore. X1 contiene i punti nei quali il polinomio
% interpolatore deve essere valutato. Y1 contiene i valori del polinomio interpoltore
%  nei nodi X1. L'algoritmo di basa sul calcolo delle differenze divise e sulla
%  valutazione del polinomio interpolatore con il metodo di Horner
x=x(:); y=y(:); n1=length(x1); y1=zeros(size(x1));
np=length(y); a = y;
for i=2:np
    for j=np:-1:i
        a(j)=(a(j)-a(j-1))/(x(j)-x(j-i+1));
    end
end
for j=1:n1
    y1(j) = a(np);
    for i =np-1:-1:1
        y1(j) = y1(j)*(x1(j)-x(i))+a(i);
    end
end
return
