function [lambda,x,iter,relres]=invpower(A,z0,mu,tol,nmax)
% INVPOWER metodo delle potenze inverse.
% [LAMBDA,X,ITER,RELRES]=INVPOWER(A,Z0,MU,TOL,NMAX) calcola l'autovalore
% LAMBDA di modulo minimo della matrice A e il corrispondente autovettore X di norma
% unitaria. TOL specifica la tolleranza del metodo. NMAX specifica il numero massimo
% di iterazioni. Z0 e` il vettore iniziale, MU lo shift e ITER l'iterazione alla quale X e`
% calcolato.
M=A-mu*speye(size(A)); [L,U,P]=lu(M);
z=z0/norm(z0); y=L \ (P*z); q=U \ y; lambda0=z'*q;
if lambda0==0; % se z'*q=0 genero z0 random
n=length(A);    z0=rand(n,1);
z=z0/norm(z0); y=L \ (P*z); q=U \ y; lambda0=z'*q;
end
err=tol*abs(lambda0)+1; iter=0; relres=err;
while err>=tol*abs(lambda0) && abs(lambda0)~=0 && iter<=nmax
   z = q/norm(q);
   y=L \ (P*z);    q=U \ y;
   lambda = z'*q;
   err = abs(lambda - lambda0);
   relres=[relres;err];
   iter = iter + 1;
   lambda0 = lambda;
end
x=q/norm(q);
lambda = 1/lambda + mu;
return
