function [x,u]=ipeidg0(I,n,a,u0,bc)
% IPEIDG0 metodo di Eulero all'indietro per dG(0) per un'equazione
% di trasporto scalare
% [U,X]=IPEIDG0(I,N,A,U0,BC) risolve l'equazione
% DU/DT+A*DU/DX=0   X in (I(1),I(2)), T in (I(3),I(4))
% con un'approssimazione ad elementi finiti spazio-tempo
nx=n(1); h=(I(2)-I(1))/nx; x=(I(1)+h/2:h:I(2))';
t=I(3);  u=u0(x);
nt=n(2); k=(I(4)-I(3))/nt;
lambda=k/h;
e=ones(nx,1);
A=spdiags([-a*lambda*e, (1+a*lambda)*e],-1:0,nx,nx);
[L,U]=lu(A);
for t = I(3)+k:k:I(4)
   f = u;
   if a > 0
      f(1) = a*bc(1)+f(1);
   elseif a <= 0
      f(nx) = a*bc(2)+f(nx);
   end
   y = L \ f; u = U \ y;
end
return
