function [A]=luband(A,p,q)
% LUBAND fattorizzazione LU per una matrice a banda.
%  Y=LUBAND(A,P,Q): U e` memorizzata nella parte triangolare superiore di Y
%  e L e` memorizzata nella parte triangolare inferiore stretta di Y,
%  per una matrice a banda A con banda inferiore di larghezza P e
%  banda superiore di larghezza Q.
[n,m]=size(A);
if n ~= m, error('Solo sistemi quadrati'); end
for k = 1:n-1
    for i = k+1:min(k+p,n), A(i,k)=A(i,k)/A(k,k);  end
    for j = k+1:min(k+q,n)
        i = k+1:min(k+p,n);
        A(i,j)=A(i,j)-A(i,k)*A(k,j);
    end
end
return
