function [A]=luijk(A)
% LUIJK fattorizzazione LU di una matrice A nella versione ijk
%   Y=LUIJK(A): U e` memorizzata nella parte triangolare superiore di Y
%   e L nella parte triangolare inferiore stretta di Y.
[n,m]=size(A);
if n ~= m, error('Solo sistemi quadrati'); end
for i=1:n
    for j=2:i
        if A(j,j)==0; error('Elemento pivotale nullo'); end
        A(i,j-1)=A(i,j-1)/A(j-1,j-1);
        k=1:j-1;   A(i,j)=A(i,j)-A(i,k)*A(k,j);
    end
    k=1:i-1;
    for j=i+1:n, A(i,j)=A(i,j)-A(i,k)*A(k,j); end
end
return
