function [A]=lujki(A)
% LUJKI fattorizzazione LU di una matrice A nella versione jki
%   Y=LUJKI(A): U e` memorizzata nella parte triangolare superiore di Y
%   e L nella parte triangolare inferiore stretta di Y.
[n,m]=size(A);
if n ~= m, error('Solo sistemi quadrati'); end
for j=1:n
    if A(j,j)==0; error('Elemento pivotale nullo'); end
    for k=1:j-1
        i=k+1:n; A(i,j)=A(i,j)-A(i,k)*A(k,j);
    end
    i=j+1:n;   A(i,j)=A(i,j)/A(j,j);
end
return
