% NEWTON metodo di Newton.
% [ZERO,ITER,XVECT,XDIF,FX]=NEWTON(FUN,DFUN,X0,TOL,NMAX) cerca lo zero
% di una funzione continua FUN nell'intervallo [A,B] usando il metodo dei Newton e
% partendo da X0. TOL e NMAX specificano la tolleranza ed il massimo numero di
% iterazioni. FUN e DFUN ricevono in ingresso lo scalare x e restituiscono un valore
% scalare reale. DFUN e` la funzione derivata di FUN.
% ZERO e` l'approssimazione della radice, ITER e` il numero di iterate svolte.
% XVECT e` il vettore delle iterate, XDIF il vettore delle differenze tra iterate
% successive, FX il vettore dei residui.
err=tol+1; iter=0; xdif=[];
fx0=fun(x0); xvect=x0; fx=fx0;
while iter < nmax && err> tol
    dfx0=dfun(x0);
    if dfx0==0
        fprintf('Arresto causa annullamento derivata\n');
        zero=[];
        return
    end
    x=x0-fx0/dfx0;
    err=abs(x-x0); x0=x; fx0=fun(x0); iter=iter+1;
    xvect=[xvect;x0]; fx=[fx;fx0]; xdif=[xdif; err];
end
zero=xvect(end);
return
