function [lambda,x,iter,relres]=powerm(A,z0,tol,nmax)
% POWERM metodo delle potenze.
% [LAMBDA,X,ITER,RELRES]=POWERM(A,Z0,TOL,NMAX) calcola l'autovalore
% LAMBDA di modulo massimo della matrice A e il corrispondente autovettore X di
% norma unitaria. TOL specifica la tolleranza del metodo. NMAX specifica il numero
% massimo di iterazioni. Z0 e` il vettore iniziale e ITER l'iterazione alla quale X e`
% calcolato. RELRES contiene la successione degli incrementi delle approssimazioni
% dell'autovalore
q=z0/norm(z0); z=A*q; lambda0=q'*z;
res=tol+1; iter=0; relres=res;
while res >= tol*abs(lambda0) && iter <= nmax
 q=z/norm(z); z=A*q;
 lambda=q'*z;
 res=abs(lambda-lambda0); relres=[relres; res];
 iter=iter+1; lambda0=lambda;
end
x=q;
return
