function [t,u]=predcor(a,b,at,bt,h,f,t0,u0,tf,pece,m)
% PREDCOR metodo predictor-corrector.
% [T,U]=PREDCOR(A,B,AT,BT,TF,T0,U0,H,FUN,PECE,M) risolve il problema di Cauchy
% Y'=FUN(T,Y), per T in (T0,TF), utilizzando il metodo predictor-corrector
% avente coefficienti AT e BT per il predictor, A e B per il corrector.
% H specifica il time step. Se PECE=1, allora si usa il metodo P(EC)^mE,
% altrimenti il metodo P(EC)^m.
u0=u0(:);t0=t0(:);
p  = max(length(a),length(b)-1);
pt = max(length(at),length(bt));
q  = max(p,pt);
if length(u0)<q, t=[]; u=[]; return, end;
t  = t0:h:t0+(q-1)*h; u = u0;  fe = f(t,u0);
k  = q;
for t = t0+q*h:h:tf
    ut=sum(at.*u(k:-1:k-pt+1))+h*sum(bt.*fe(k:-1:k-pt+1));
    foy=f(t,ut);
    uv=sum(a.*u(k:-1:k-p+1))+h*sum(b(2:p+1).*fe(k:-1:k-p+1));
    k = k+1;
    for j=1:m
        fy=foy; up=uv+h*b(1)*fy; foy=f(t,up);
    end
    if strcmp(pece,'y') || strcmp(pece,'Y')
        fe=[fe;foy];
    else
       fe=[fe;fy];
    end
    u=[u;up];
end
t=(t0:h:tf)';
return
