function [T,iter]=qrshift(A,tol,nmax)
% QRSHIFT iterazione QR iteration con singolo shift..
%  [T,ITER]=QRSHIFT(A,TOL,NMAX) calcola dopo ITER iterazioni la decomposizione
%  reale di Schur T di una matrice A con una tolleranza TOL.
%  NMAX specifica il numero massimo di iterazioni.
[n,m]=size(A);
if n~=m, error('Solo matrici quadrate'); end
iter=0; [T,Q]=houshess(A);
for k=n:-1:2
    I=eye(k);
    while abs(T(k,k-1))>tol*(abs(T(k,k))+abs(T(k-1,k-1)))
        iter=iter+1;
        if iter > nmax
            return
        end
        mu=T(k,k); [Q,R,c,s]=qrgivens(T(1:k,1:k)-mu*I);
        T(1:k,1:k)=R*Q+mu*I;
    end
    % T(k,k-1)=0;
end
return
