function int=redmidpt(a,b,phi1,phi2,m,fun)
% REDMIDPT formula di quadratura di riduzione del punto medio.
% INT=REDMIDPT(A,B,PHI1,PHI2,M,FUN) calcola l'integrale della funzione FUN sul
% dominio 2D avente X in (A,B) e Y delimitato dalle funzioni PHI1 e PHI2.
% FUN e` una funzione delle variabili X e Y
H=(b-a)/m;
xx=(a+H/2:H:b);
psi=zeros(m,1);
for i=1:m
    d=phi2(xx(i)); c=phi1(xx(i));
    h=(d-c)/m; y=(c+h/2:h:d); dim=length(y);
    w=fun(xx(i),y).*ones(1,dim);
    psi(i)=h*sum(w(1:m));
end
int=H*sum(psi(1:m));
return
