function int=redtrap(a,b,phi1,phi2,m,fun)
% REDTRAP formula di quadratura di riduzione del trapezio.
% INT=REDTRAP(A,B,PHI1,PHI2,M,FUN) calcola l'integrale della funzione FUN sul
% dominio 2D avente X in (A,B) e Y delimitato dalle funzioni PHI1 e PHI2.
% FUN e` una funzione delle variabili X e Y
H=(b-a)/m;
xx=(a:H:b);
dimx=m+1; psi=zeros(dimx,1);
for i=1:dimx
    d=phi2(xx(i)); c=phi1(xx(i));
    h=(d-c)/m; y=(c:h:d); dimy=length(y);
    w=fun(xx(i),y).*ones(1,dimy);
    psi(i)=h*(0.5*w(1)+sum(w(2:m))+0.5*w(m+1));
end
int=H*(0.5*psi(1)+sum(psi(2:m))+0.5*psi(m+1));
return
