function int = romberg(a,b,n,fun)
% ROMBERG integrazione di Romberg.
% INT=ROMBERG(A,B,N,FUN) calcola un'approssimazione dell'integrale della funzione
% FUN su (A,B) con il metodo di Romberg.
% FUN riceve in ingresso un vettore reale x e restituisce un vettore della
% stessa dimensione di x.
for m=0:n
    A(m+1,1)=trapezc(a,b,2^m,fun);
end
for q=0:n-1
  for m=q+1:n
    A(m+1,q+2)=(4^(q+1)*A(m+1,q+1)-A(m,q+1))/(4^(q+1)-1);
  end
end
int=A(n+1,n+1);
return
