function [x,iter]=sor(A,b,x0,nmax,tol,omega)
% SOR metodo SOR
%  [X,ITER]=SOR(A,B,X0,NMAX,TOL,OMEGA) risolve il sistema
%  A*X=B con il metodo SOR. TOL specifica la tolleranza del metodo,
%  NMAX il numero massimo di iterazioni, mentre X0 e` il vettore iniziale.
%  OMEGA e` il parametro di rilassamento, ITER indica l'iterazione alla
%  quale e` calcolata la soluzione X.
[n,m]=size(A);
if n ~= m, error('Solo sistemi quadrati'); end
iter=0; r=b-A*x0; r0=norm(r); err=norm(r); xold=x0;
while err > tol && iter < nmax
    iter = iter + 1;
    for i=1:n
        s=0;
        for j = 1:i-1, s=s+A(i,j)*x(j); end
        for j = i+1:n, s=s+A(i,j)*xold(j); end
        x(i,1)=omega*(b(i)-s)/A(i,i)+(1-omega)*xold(i);
    end
    xold=x;  r=b-A*x; err=norm(r)/r0;
end
return
